%<<<<<<<<<<<<<<<<<<<<<<<<<<<<< Main function >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
function Cortex_System
%This program looks at the eigth order equation
%Marcus Wilson 30 July 2004
%This programme calls Alistair's to do a loop around the manifold
%11 August 2004  Peforms a simple simulation of the eighth-order system
%12 August 2004 - Let's put some space terms in. 16 spatial points, cyclic
%18 August 2004 - Make it a 2d system, 16 by 16 points.
%19 August 2004 - Puts the subcortical terms in a 'noise' form. See p357
%6 September 2004 - Allow us to move up and down a path in lambda_Ach etc
%22 October 2004 - Does a spatial fourier analysis of the spatial states
%                 and saves the final svec containing the history
%12 November 2004 - See p436. Correction to noise term so it scales the
%spatial noise correctly.
%5 January 2005. Use predictor corrector method. See p 524.
%Theory is in Kloeden and Platen section 15.5
%14 January 2005. Modified to allow us to simulate an anaesthetic. See p536
% Use secs and mm and mV as fundamental units
%24 January 2005. Allows us to find stationary states with lambda_i as a
%control variable
%31 March 2005. delV_rest is a matrix so we can make easy changes to
%excitability. Path trajectories defined.
%

% Jay Chang
% 06 Sep 2006 -
% allow user to select either upper-branch or bottom-branch of the
% equilibrium for the initial condition of the variables.
% 11 Sep 2006 - 
% move the derivative part to the first-order derivative function for the
% 14 variables(Ve, Vi, ..., etc.), then change the iterate_by_step function
% to Runge_Kutta_Integration function, and add RK4 method to the function.
% User now can select either RK2 or RK4 for numerical integration.
% 13 Sep 2006 - 
% move the section of codes for finding the initial values for the
% variables to steady_states_finder function.
% 14 Sep 2006 - 
% move the section of codes for noises to noise function.
% 20 Sep 2006 -
% move the section of codes for trajectory to find_trajec function.
% move the section of codes for kick change to perturbation function.
% modify the inputs for each input function, so the input functions read
% most of their input parameters from the input function.
% modify the output of noise function: the output of noise function
% overwirtes the noise value into input function.
% modify the output of find_trajec function: the output parameters are
% overwrote into the input function.
% 26 Sep 2006 -
% moved the section of code for plotting the graph to function
% graph_output.
% moved the section of code for saving the movie & data to function
% save_output.
% add flag control for user's option to save the movie & data or not.
% Nov 2006
% add 14x14 & 2x2 stability test functions. data_output function modified.
% the data_output function now can do & record the 14x14 stability test.
clear all;

format long;

global H;
H=init_hasselmo_globs;	% Set the global parameters for constants
global I;
I = Input;              % Set the global parameters for inputs

[deltat tend RK Input_FUN] = deal(I.deltat, I.tend, I.RK, I.FUN);

rand('state',57972);        % Generates a random seed

f = find_steady_states;% Now get the initial condition for numerical integration

 for t=0:tend           % Now loop over time
     
     find_trajec(t);    % Now calculate the trajectory we take in phase space if we need it
     
     noise;             % Now generate the noise
     
                        % Now start the incrementation.
     f = Runge_Kutta_Integration(Input_FUN, t, f, deltat, RK);
     
     perturbation(t);   % Now we do a kick if necessary
     
     data_output(t, f); % Plot the graph & records data

 end                    % Next time step in the overall loop

    save_output;        % Save the output values & movie
    
    fprintf('\nCopyright (C) 2007. The University of Waikato. \nAll Rights Reserved. \n\n http://phys.waikato.ac.nz/cortex \n\n');

return
%<<<<<<<<<<<<<<<<<<<<<<<<< End of Main function >>>>>>>>>>>>>>>>>>>>>>>>>>>