function data_output(t, f)
% This function plots the graph of the chosen variable & output the data
% to global for saving
% 8 Jan 2006 -
% the value for tplot is defined by t & t_step_4_tplot, instead of calling
% from global I.
% 9 Jan 2006 -
% add stability test in this function.
global I;
global O;

t_step_4_tplot = I.t_step_4_tplot;

% recording the svector for every number of t steps
if (mod(t,t_step_4_tplot) == 0)
    tplot = floor(t/t_step_4_tplot)+1;
    [dataFlag t_step_4_graph saved_variable tend] = deal(I.dataFlag, ...
        I.t_step_4_graph, I.saved_variable, I.tend);
    % calculate and display the % of the completion for the simulation
    fprintf('Simulation Progress: %g%% completed.\n\n',t/tend*100)
    if (dataFlag == true)
        % records data to global
        f(:,:,end+1) = Qsige(f(:,:,1));
        % put Qe into f matrix to be the 15th variable
        f(:,:,end+1) = Qsigi(f(:,:,2));
        % put Qi into f matrix to be the 16th variable
        O.svec(:,:,:,tplot) = f(:,:,saved_variable);
        if (I.stabilityFlag == true)
            % finds steady-states with current parameters(e.g. lambda_Ach)
            % and calculates for stability. This is only necessary if there
            % is a trajectory.
            find_steady_states;
        end     % end of the stability test
    end         % end of the data calculation and transfering
    
    % Plot out the simulated cortex
    if (t_step_4_graph ~= 0) && (mod(t,t_step_4_graph) == 0)
        t_movie = floor(t/t_step_4_graph)+1;
        [movieFlag plotted_variable x_axis_range y_axis_range ...
            z_axis_range xtick ytick x_axis_label y_axis_label ...
            z_axis_label] = deal(...
            I.movieFlag, I.plotted_variable, I.x_axis_range, ...
            I.y_axis_range, I.z_axis_range, I.xtick, I.ytick, ...
            I.x_axis_label, I.y_axis_label, I.z_axis_label);
        figure(3)   % 3-D cortex
        mesh(f(:,:,plotted_variable))
        %surf(f(:,:,plotted_variable))
        set(gca,'xlim',x_axis_range);
        set(gca,'ylim',y_axis_range);
        set(gca,'zlim',z_axis_range);
        set(gca,'xtick',xtick);
        set(gca,'ytick',ytick);
        xlabel(x_axis_label);
        ylabel(y_axis_label);
        zlabel(z_axis_label);
        
        drawnow;
        
        if (movieFlag == true)
            % records the frame for the movie to global
            O.Mmovie(t_movie)=getframe;
        end

        figure(2)   % 2-D cortex
        mesh(f(:,:,plotted_variable))
        %surf(f(:,:,plotted_variable))
        view(0, 90);
        drawnow;
        
    end	% end tplot if statement for meshing
end     % end tplot if statement for recording the svector
     
return