function find_trajec(t)
%This function does a trajectory in phase space for a given time
%Marcus Wilson 14 January 2005
% See p536 in notebook
% 20 March 2005 - Changed to be more accurate - as in the track_drugs
% programme.
%
global I;
[tend lambda_i gamma_i lambda_Ach del_Vrest Nspace trajectory ...
    gamma_inhib_standard lambda_inhib_standard] = ...
    deal(I.tend, I.lambda_i, I.gamma_i, I.lambda_Ach, I.del_Vrest, ...
    I.Nspace, I.trajectory, I.gamma_inhib_standard, I.lambda_inhib_standard);

switch trajectory
    case 0
        I.lambda_i=1;
        %For normal cases lambda_i remains at 1 - equiv of lambda_ACh
        %gamma_i is untouched.
    case 1
        max_drug=1.2;           %drug in mM end of path
        x=max_drug*(t/tend) ;	%Our value for the drug conc
        %enflurane
        gamma_i_ratio = -0.9679*x^3 + 2.7015*x^2 - 2.4783*x + 0.9961;
        lambda_inhib_ratio = -1.2106*x^3 - 0.1915*x^2 + 2.7004*x + 0.9761;
        
        %isoflurane
%        if (x < 0.6);
%            gamma_i_ratio = -1.9017*x^3 + 4.4384*x^2 - 3.228*x + 0.9878;
%        else
%            gamma_i_ratio = 0.23;
%        end
%        lambda_inhib_ratio = -3.7335*x^3 +2.1785*x^2 + 4.4188*x + 1.0125;

I.gamma_i = gamma_inhib_standard*gamma_i_ratio;         % Whatever for our drug
I.lambda_i = lambda_inhib_standard*lambda_inhib_ratio;	% Whatever for our drug
          
    case 2
            I.lambda_Ach = lambda_Ach - 0.25/tend;

    otherwise
        warning('Unknown trajectory!');
        error('Only "0", "1" or "2" are acceptable for "trajectory" input');
end

return