function dfdt = first_order_derivative(time, f, deltat)
% This function finds the first order derivative of the variables
global H;
global I;    
Ve = f(:,:,1);
Vi = f(:,:,2);
PHI_ee = f(:,:,3);
Xee = f(:,:,4);
PHI_ei = f(:,:,5);
Xei = f(:,:,6);
PHI_ie = f(:,:,7);
Xie = f(:,:,8);
PHI_ii = f(:,:,9);
Xii = f(:,:,10);
phi_ee = f(:,:,11);
Yee = f(:,:,12);
phi_ei = f(:,:,13);
Yei = f(:,:,14);

% calls out the user-input figures
[lambda_Ach gamma_e gamma_i nu v lamda_ee ...
    deltax Nspace macsperbrain lambda_i del_Vrest] = deal( ...
    I.lambda_Ach, I.gamma_e, I.gamma_i, I.nu, I.v, I.lamda_ee, ...
    I.deltax, I.Nspace, I.macsperbrain, I.lambda_i, I.del_Vrest_mat);

% calls out the constants
[Ve_rev Vi_rev Ve_rest Vi_rest rho_i rho_e ...
    N_ee_a N_ei_a N_ee_b N_ei_b N_ie_b N_ii_b ...
    phi_ee_sc phi_ei_sc phi_ie_sc phi_ii_sc ...
    ] = deal(H.Ve_rev, H.Vi_rev, H.Ve_rest, H.Vi_rest, H.gi, H.ge, ...
    H.Nee_a, H.Nei_a, H.Nee_b, H.Nei_b, H.Nie_b, H.Nii_b, ...
    H.phi_ee_sc, H.phi_ei_sc, H.phi_ie_sc, H.phi_ii_sc);
     
% calls out the noises
[Ree Rei Rie Rii] = deal(I.R(:,:,1), I.R(:,:,2), I.R(:,:,3), I.R(:,:,4));
     
tau_e = H.tau_e * 0.001;	%Puts tau_e in seconds
tau_i = H.tau_i * 0.001;	%Puts tau_i in seconds
     
%Calculate the derivatives - use vector form
psi_ee = Psi_ee(Ve);
psi_ei = Psi_ei(Vi);
psi_ie = Psi_ie(Ve);
psi_ii = Psi_ii(Vi);
Qe=Qsige(Ve);
Qi=Qsigi(Vi);
     %
     
incVe = (1/tau_e)*(Ve_rest+del_Vrest - Ve + rho_e*lambda_Ach*psi_ee.*...
    PHI_ee + rho_i*lambda_i*psi_ie.*PHI_ie);
incVi = (1/tau_i)*(Vi_rest - Vi + rho_e*lambda_Ach*psi_ei.*PHI_ei + ...
    rho_i*lambda_i*psi_ii.*PHI_ii);
incPHI_ee = Xee;
incXee = -2*gamma_e*Xee - gamma_e^2*PHI_ee + gamma_e^2*(N_ee_a*phi_ee + ...
    N_ee_b*Qe + (1-nu)*phi_ee_sc+nu*Ree*Nspace^2/(deltat*macsperbrain));
incPHI_ie = Xie;
incXie = -2*gamma_i*Xie - gamma_i^2*PHI_ie + gamma_i^2*(N_ie_b*Qi + ...
    (1-nu)*phi_ie_sc+nu*Rie*Nspace^2/(deltat*macsperbrain));
incPHI_ii = Xii;
incXii = -2*gamma_i*Xii - gamma_i^2*PHI_ii + gamma_i^2*(N_ii_b*Qi + ...
    (1-nu)*phi_ii_sc+nu*Rii*Nspace^2/(deltat*macsperbrain));
incPHI_ei = Xei;
incXei = -2*gamma_e*Xei - gamma_e^2*PHI_ei + gamma_e^2*(N_ei_a*phi_ei + ...
    N_ei_b*Qe + (1-nu)*phi_ei_sc+nu*Rei*Nspace^2/(deltat*macsperbrain));
incphi_ee = Yee;
incphi_ei = Yei;
%Next are the space terms. Use cyclic boundary conditions
for x=1:Nspace; %Do the x term
    xup=x+1;
    if (xup > Nspace)
        xup=1;  %cyclic permute
    end
    xdown=x-1;
    if (xdown < 1)
        xdown=Nspace;
    end

    for y=1:Nspace  %Now do the y term
        yup = y+1;
        if (yup > Nspace)
            yup=1;
        end
        ydown=y-1;
        if (ydown < 1)
            ydown=Nspace;
        end
        incYee(x,y) = -2*v*lamda_ee*Yee(x,y) - lamda_ee^2*v^2*phi_ee(x,y) + ...
            v^2*(-4*phi_ee(x,y)+phi_ee(xup,y) + phi_ee(xdown,y) + ...
            phi_ee(x,yup)+phi_ee(x,ydown))/deltax^2 + v^2*lamda_ee^2*Qe(x,y);
        incYei(x,y) = -2*v*lamda_ee*Yei(x,y) - lamda_ee^2*v^2*phi_ei(x,y) + ...
                     v^2*(-4*phi_ei(x,y)+phi_ei(xup,y)+ phi_ei(xdown,y) + ...
                     phi_ei(x,yup)+phi_ei(x,ydown)) / deltax^2 + ...
                     v^2*lamda_ee^2*Qe(x,y);
                 %Now just do the next x and y
    end
end
     
% return the 1st-order-derivative of the variables
dfdt(:,:,1) = incVe;
dfdt(:,:,2) = incVi;
dfdt(:,:,3) = incPHI_ee;
dfdt(:,:,4) = incXee;
dfdt(:,:,5) = incPHI_ei;
dfdt(:,:,6) = incXei;
dfdt(:,:,7) = incPHI_ie;
dfdt(:,:,8) = incXie;
dfdt(:,:,9) = incPHI_ii;
dfdt(:,:,10) = incXii;
dfdt(:,:,11) = incphi_ee;
dfdt(:,:,12) = incYee;
dfdt(:,:,13) = incphi_ei;
dfdt(:,:,14) = incYei;
return