function noise
% This function generates the noise for the cortex
     %Poisson for noise on subcortical terms. Do before predictor because
     %we need to keep same random term for both halves.
     %CORRECTION 12 Nov 04 - p476 and p434
% 01 Feb 2007 - modified to use FOR loop to replace the repeating codes
global I;
[Nspace macsperbrain deltat poissflag] = ...
    deal(I.Nspace, I.macsperbrain, I.deltat, I.poissflag);

global H;
% calles the mean firing per sec per neuron
phi_sc = [H.phi_ee_sc H.phi_ei_sc H.phi_ie_sc H.phi_ii_sc]; 

vmat=[Nspace Nspace];  %defines size of matrix of noise terms

%Poisson lambda for the timestep deltat - i.e. expected number of pulses
lambda_phi = macsperbrain*phi_sc * deltat/Nspace^2;

for i = 1 : length(phi_sc)
    if (poissflag)
        %Generates the random matrix for the phi_sc and return the noise
        %vectors to global
        I.R(:,:,i) = poissrnd(lambda_phi(i), vmat);
    else
        %Generates gaussian to speed things up
        I.R(:,:,i) = normrnd(lambda_phi(i), sqrt(lambda_phi(i)), vmat);
    end
end

return