function save_output
% This function saves the data & movie
global I;
global O;

[dataFlag movieFlag t_step_4_graph] = deal(I.dataFlag, I.movieFlag, I.t_step_4_graph);

if (dataFlag == true)
    % calls out variables from global O & I
    [svec Equilibrium eigenvalues_14x14 largest_eigenvalue_14x14 ...
        oscillation_freq_14x14] = deal(O.svec, O.Equilibrium, ...
        O.eigenvalues_14x14, O.largest_eigenvalue_14x14, O.oscillation_freq_14x14);
    [tend Nspace deltat deltax lcortex t_step_4_tplot] = deal(...
        I.tend, I.Nspace, I.deltat, I.deltax, I.lcortex, I.t_step_4_tplot);
    % saves the data with stability test to file "firing_rates_etc"
    save(I.DataFileName, ...
        'svec', 'tend', 'Nspace', 'deltat', 'deltax', 'lcortex', ...
        't_step_4_tplot', 'Equilibrium', 'eigenvalues_14x14', ...
        'largest_eigenvalue_14x14', 'oscillation_freq_14x14');
end
    
if (t_step_4_graph ~= 0) && (movieFlag == true)	% Saves the movie
    Mmovie = O.Mmovie;	% calls out the frames from global
    save(I.MovieFileName, 'Mmovie'); 
    movie2avi(Mmovie,I.MovieFileName);
end

return